package com.cuinacat.darwin.cuinacat;

/**
 * Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
 */

import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.support.v4.app.Fragment;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.Spinner;
import android.widget.Toast;
import java.util.ArrayList;

public class BuscadorFam extends Fragment {

    private ImageButton sopes,amanides,llegums,verdures,pasta,arros,peix,carn,postres,botCerca;
    private EditText inCerca;
    private Intent intent;
    private String filFam;
    private Boolean filtreTemps,filtreFamilia;
    private int filtreTempsMin,filtreTempsMax;
    private ArrayList<String> noms,parseIds,families;
    private DBHelper BD;
    public SQLiteDatabase myDataBase;
    public static String DB_PATH = "/data/data/com.cuinacat.darwin.cuinacat/databases/";
    public static String DB_NAME = "Datos.db";
    public static String rutadb = DB_PATH + DB_NAME;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.buscador_fam, container, false);

        sopes = (ImageButton) view.findViewById(R.id.sopes);
        sopes.setOnClickListener(lis);
        amanides = (ImageButton) view.findViewById(R.id.amanides);
        amanides.setOnClickListener(lis);
        llegums = (ImageButton) view.findViewById(R.id.llegums);
        llegums.setOnClickListener(lis);
        verdures = (ImageButton) view.findViewById(R.id.verdures);
        verdures.setOnClickListener(lis);
        pasta = (ImageButton) view.findViewById(R.id.pasta);
        pasta.setOnClickListener(lis);
        arros = (ImageButton) view.findViewById(R.id.arros);
        arros.setOnClickListener(lis);
        peix = (ImageButton) view.findViewById(R.id.peix);
        peix.setOnClickListener(lis);
        carn = (ImageButton) view.findViewById(R.id.carn);
        carn.setOnClickListener(lis);
        postres = (ImageButton) view.findViewById(R.id.postres);
        postres.setOnClickListener(lis);
        botCerca = (ImageButton) view.findViewById(R.id.cerca);
        botCerca.setOnClickListener(lis);
        inCerca = (EditText) view.findViewById(R.id.inCerca);

        //SPINNER FAMILIA
        Spinner spFam = (Spinner) view.findViewById(R.id.spinnerFamilies);
        ArrayAdapter<CharSequence> adapter1 = ArrayAdapter.createFromResource(getActivity(),
                R.array.arrayFamilies, android.R.layout.simple_spinner_item);
        adapter1.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spFam.setAdapter(adapter1);
        spFam.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                switch (position){
                    case 0:
                        filtreFamilia = false;
                        break;
                    default:
                        filtreFamilia = true;
                        filFam = parent.getItemAtPosition(position).toString();
                        break;
                }
            }
            @Override
            public void onNothingSelected(AdapterView<?> parent) {}
        });

        //SPINNER TEMPS
        Spinner spTem = (Spinner) view.findViewById(R.id.spinnerTemps);
        ArrayAdapter<CharSequence> adapter2 = ArrayAdapter.createFromResource(getActivity(),
                R.array.arrayTemps, android.R.layout.simple_spinner_item);
        adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spTem.setAdapter(adapter2);
        spTem.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                switch (position){
                    case 0:
                        filtreTemps = false;
                        break;
                    case 1:
                        filtreTemps = true;
                        filtreTempsMin = 0;
                        filtreTempsMax = 30;
                        break;
                    case 2:
                        filtreTemps = true;
                        filtreTempsMin = 31;
                        filtreTempsMax = 60;
                        break;
                    case 3:
                        filtreTemps = true;
                        filtreTempsMin = 61;
                        filtreTempsMax = 240;
                        break;
                }
            }
            @Override
            public void onNothingSelected(AdapterView<?> parent) {}
        });

        return view;
    }

    View.OnClickListener lis= new View.OnClickListener() {//Listener
        @Override
        public void onClick(View v) {
            switch (v.getId()) {
                case R.id.sopes:
                    buscarFamilia("Sopes");
                    break;
                case R.id.amanides:
                    buscarFamilia("Amanides");
                    break;
                case R.id.llegums:
                    buscarFamilia("Llegums");
                    break;
                case R.id.verdures:
                    buscarFamilia("Verdures");
                    break;
                case R.id.pasta:
                    buscarFamilia("Pasta");
                    break;
                case R.id.arros:
                    buscarFamilia("Arròs");
                    break;
                case R.id.carn:
                    buscarFamilia("Carn");
                    break;
                case R.id.peix:
                    buscarFamilia("Peix");
                    break;
                case R.id.postres:
                    buscarFamilia("Postres");
                    break;
                case R.id.cerca:
                    String cerca = inCerca.getText().toString();
                    if (cerca.equals(""))
                        error("No s'ha introduit cap text de cerca");
                    else
                        cercar(cerca);
                    break;

            }
        }
    };

    private void cercar(String cerca){
        String consulta;
        noms = new ArrayList<>();
        parseIds = new ArrayList<>();
        families = new ArrayList<>();
        BD = new DBHelper(getActivity());
        BD.open();
        if (!filtreFamilia && !filtreTemps){
             consulta = "" + "SELECT nom, idParse, familia FROM Recepta WHERE nom like '%"+cerca+"%'";
        }
        else if(!filtreFamilia){
            consulta = "" + "SELECT nom, idParse, familia FROM Recepta WHERE (nom like '%"+cerca+"%' AND temps BETWEEN "+filtreTempsMin+" AND "+filtreTempsMax+ ")";
        }
        else if(!filtreTemps){
            consulta = "" + "SELECT nom, idParse, familia FROM Recepta WHERE (nom like '%"+cerca+"%' AND familia = '"+filFam+"')";
        }
        else{
            consulta = "" + "SELECT nom, idParse, familia FROM Recepta WHERE (nom like '%"+cerca+"%' AND familia = '"+filFam+"'  AND temps BETWEEN "+filtreTempsMin+" AND "+filtreTempsMax+ ")";
        }
        try {
            myDataBase = SQLiteDatabase.openDatabase(rutadb, null, SQLiteDatabase.OPEN_READONLY);
            Cursor c = myDataBase.rawQuery(consulta, null);
            if (c != null) {
                if (c.moveToFirst()) {
                    do {
                        noms.add(c.getString(c.getColumnIndex("nom")));
                        parseIds.add(c.getString(c.getColumnIndex("idParse")));
                        families.add(c.getString(c.getColumnIndex("familia")));
                        Log.e("RESULTATS", c.getString(c.getColumnIndex("nom")) + "    " + c.getString(c.getColumnIndex("idParse")));
                    } while (c.moveToNext());
                }
                c.close();
            }
        }catch (Exception e){Log.e("ERROR BUSCAR FAMILIA",e.toString());}
        BD.close();
        intent = new Intent(getActivity(),Resultats.class);
        intent.putExtra("noms",noms);
        intent.putExtra("parseIds",parseIds);
        intent.putExtra("families",families);
        startActivity(intent);
        getActivity().overridePendingTransition(R.anim.left_in, R.anim.left_out);
        getActivity().finish();
    }

    private void buscarFamilia(String familia) {
        noms = new ArrayList<>();
        parseIds = new ArrayList<>();
        families = new ArrayList<>();
        BD = new DBHelper(getActivity());
        BD.open();
        String consulta = "" + "SELECT nom, idParse, familia FROM Recepta WHERE familia = '" + familia + "'";
        try {
            myDataBase = SQLiteDatabase.openDatabase(rutadb, null, SQLiteDatabase.OPEN_READONLY);
            Cursor c = myDataBase.rawQuery(consulta, null);
            if (c != null) {
                if (c.moveToFirst()) {
                    do {
                        noms.add(c.getString(c.getColumnIndex("nom")));
                        parseIds.add(c.getString(c.getColumnIndex("idParse")));
                        families.add(c.getString(c.getColumnIndex("familia")));
                        Log.e("RESULTATS", c.getString(c.getColumnIndex("nom")) + "    " + c.getString(c.getColumnIndex("idParse")));
                    } while (c.moveToNext());
                }
                c.close();
            }
        } catch (Exception e) {
            Log.e("ERROR BUSCAR FAMILIA", e.toString());
        }
        BD.close();
        intent = new Intent(getActivity(), Resultats.class);
        intent.putExtra("noms", noms);
        intent.putExtra("parseIds", parseIds);
        intent.putExtra("families", families);
        startActivity(intent);
        getActivity().overridePendingTransition(R.anim.left_in, R.anim.left_out);
        getActivity().finish();
    }

    private void error(String missatge){
        Toast toast = Toast.makeText(getActivity(), missatge, Toast.LENGTH_LONG);
        toast.show();
    }

}
