package com.cuinacat.darwin.cuinacat;

/**
 * Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
 */

import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import  android.support.v4.app.Fragment;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.Toast;
import java.util.ArrayList;
import java.util.List;

public class BuscadorIng extends Fragment {

    private ImageButton recom1,recom2,recom3;
    private ListView listIngredients;
    private ArrayList<String> arraySeleccionats;
    private List<String> arrayIng;
    private boolean filtreTemps;
    private int filtreTempsMin,filtreTempsMax,selectedItem;
    private String ingredient;
    private DBHelper BD;
    public SQLiteDatabase myDataBase;
    public static String DB_PATH = "/data/data/com.cuinacat.darwin.cuinacat/databases/";
    public static String DB_NAME = "Datos.db";
    public static String rutadb = DB_PATH + DB_NAME;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.buscador_ing, container, false);

        ImageButton afegirIng = (ImageButton) view.findViewById(R.id.afegirIng);
        afegirIng.setOnClickListener(lis);
        ImageButton esborrarIng = (ImageButton) view.findViewById(R.id.esborrarIng);
        esborrarIng.setOnClickListener(lis);
        Button botCerca = (Button) view.findViewById(R.id.botCerca);
        botCerca.setOnClickListener(lis);
        ImageButton recom1 = (ImageButton) view.findViewById(R.id.recom1);
        recom1.setOnClickListener(lis);
        ImageButton recom2 = (ImageButton) view.findViewById(R.id.recom2);
        recom2.setOnClickListener(lis);
        ImageButton recom3 = (ImageButton) view.findViewById(R.id.recom3);
        recom3.setOnClickListener(lis);

        listIngredients = (ListView) view.findViewById(R.id.listIngredients);
        listIngredients.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
        arraySeleccionats = new ArrayList<>();
        crearLista();

        //SPINNER INGREDIENTS
        crearArrayIngredients();
        Spinner spIng = (Spinner) view.findViewById(R.id.spinnerIngredients);
        ArrayAdapter<String> adapter1 = new ArrayAdapter<>(getActivity(),
                android.R.layout.simple_spinner_item, arrayIng);
        adapter1.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spIng.setAdapter(adapter1);
        spIng.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                ingredient = parent.getItemAtPosition(position).toString();
            }
            @Override
            public void onNothingSelected(AdapterView<?> parent) {
            }
        });

        //SPINNER TEMPS
        Spinner spTem = (Spinner) view.findViewById(R.id.spinnerTemps);
        ArrayAdapter<CharSequence> adapter2 = ArrayAdapter.createFromResource(getActivity(),
                R.array.arrayTemps, android.R.layout.simple_spinner_item);
        adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spTem.setAdapter(adapter2);
        spTem.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                switch (position){
                    case 0:
                        filtreTemps = false;
                        break;
                    case 1:
                        filtreTemps = true;
                        filtreTempsMin = 0;
                        filtreTempsMax = 30;
                        break;
                    case 2:
                        filtreTemps = true;
                        filtreTempsMin = 31;
                        filtreTempsMax = 60;
                        break;
                    case 3:
                        filtreTemps = true;
                        filtreTempsMin = 61;
                        filtreTempsMax = 240;
                        break;
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {
            }
        });

        return view;
    }

    View.OnClickListener lis= new View.OnClickListener() {//Listener
        @Override
        public void onClick(View v) {
            switch (v.getId()) {
                case R.id.afegirIng:
                        if(arraySeleccionats.size() > 4)
                            error("ERROR, MÀXIM 5 INGREDIENTS");
                        else
                            arraySeleccionats.add(ingredient);
                        crearLista();
                    break;
                case R.id.esborrarIng:
                        arraySeleccionats.remove(ingredient);
                        crearLista();
                    break;
                case R.id.botCerca:
                    cercar();
                    break;
                case R.id.recom1:
                    veureRecomenacio("2jNYf8ieom");
                    break;
                case R.id.recom2:
                    veureRecomenacio("BzGRSOeCAi");
                    break;
                case R.id.recom3:
                    veureRecomenacio("Ul9Vrkhbid");
                    break;
            }
        }
    };

    private void crearArrayIngredients(){
        arrayIng = new ArrayList<>();
        BD = new DBHelper(getActivity());
        BD.open();
        String consulta = "" +
                "SELECT nom FROM Ingredient ORDER BY nom ASC";
        try {
            myDataBase = SQLiteDatabase.openDatabase(rutadb, null, SQLiteDatabase.OPEN_READONLY);
            Cursor c = myDataBase.rawQuery(consulta, null);
            if (c != null) {
                if (c.moveToFirst()) {
                    do {
                        arrayIng.add(c.getString(c.getColumnIndex("nom")));
                    } while (c.moveToNext());
                }
                c.close();
            }
        }catch (Exception e){
            Log.e("ERROR BUSCAR INGREDIENT",e.toString());
        }
        BD.close();
    }

    private void crearLista() {
        ListIngredientAdapter listAdapter = new ListIngredientAdapter(getActivity(), arraySeleccionats, selectedItem);
        listIngredients.setAdapter(listAdapter);
        Log.e("SELECTED ITEM", String.valueOf(selectedItem));
        listIngredients.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                selectedItem = position;
                ingredient = parent.getItemAtPosition(position).toString();
                crearLista();
            }
        });
        Log.e("ARRAY SIZE", String.valueOf(arraySeleccionats.size()));
    }

    private void cercar(){
        Boolean noIng = false;
        ArrayList<String> noms = new ArrayList<>();
        ArrayList<String> parseIds = new ArrayList<>();
        ArrayList<String> families = new ArrayList<>();
        BD = new DBHelper(getActivity());

        String consulta = "SELECT nom, idParse, familia FROM Recepta WHERE (";
        switch (arraySeleccionats.size()){
            case 0:
                error("NO HA SELECCIONAT CAP INGREDIENT PER LA CERCA");
                noIng = true;
                break;
            case 1:
                consulta = consulta+ "ingredients LIKE '%"+arraySeleccionats.get(0)+"%'";
                break;
            default:
                for (int i = 0; arraySeleccionats.size() > i; i++){
                    if(arraySeleccionats.size()-1 == i)
                        consulta = consulta + "ingredients LIKE '%" + arraySeleccionats.get(i) + "%'";
                    else
                        consulta = consulta + "ingredients LIKE '%"+arraySeleccionats.get(i)+"%' AND ";
                    Log.e("ITERACIONS", arraySeleccionats.get(i));
                }
                break;
        }
        if(!filtreTemps)
            consulta = consulta + ")";
        else
            consulta = consulta + " AND temps BETWEEN "+filtreTempsMin+" AND "+filtreTempsMax+ ")";

        if (!noIng) {
            BD.open();
            try {
                myDataBase = SQLiteDatabase.openDatabase(rutadb, null, SQLiteDatabase.OPEN_READONLY);
                Cursor c = myDataBase.rawQuery(consulta, null);
                if (c != null) {
                    if (c.moveToFirst()) {
                        do {
                            noms.add(c.getString(c.getColumnIndex("nom")));
                            parseIds.add(c.getString(c.getColumnIndex("idParse")));
                            families.add(c.getString(c.getColumnIndex("familia")));
                            Log.e("RESULTATS", c.getString(c.getColumnIndex("nom")) + "    " + c.getString(c.getColumnIndex("idParse")));
                        } while (c.moveToNext());
                    }
                    c.close();
                }
            } catch (Exception e) {
                Log.e("ERROR INGREDIENTS", e.toString());
            }
            BD.close();
            Intent intent = new Intent(getActivity(), Resultats.class);
            intent.putExtra("noms", noms);
            intent.putExtra("parseIds", parseIds);
            intent.putExtra("families", families);
            startActivity(intent);
            getActivity().overridePendingTransition(R.anim.left_in, R.anim.left_out);
            getActivity().finish();
        }
    }

    private void error(String missatge){
        Toast toast = Toast.makeText(getActivity(), missatge, Toast.LENGTH_LONG);
        toast.show();
    }

    private void veureRecomenacio(String parseId){
        Intent intent = new Intent(getActivity(),Recepta.class);
        intent.putExtra("idParse",parseId);
        startActivity(intent);
        getActivity().overridePendingTransition(R.anim.left_in, R.anim.left_out);
    }
}
