package com.cuinacat.darwin.cuinacat;

/**
 * Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
 */

import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import  android.support.v4.app.Fragment;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.Toast;

import java.util.ArrayList;

public class Carro extends Fragment {

    ListView llistaCarro;
    ArrayList<String> noms = new ArrayList<>();
    ArrayList<String> parseIds = new ArrayList<>();
    ArrayList<String> families = new ArrayList<>();
    private Integer selectedItem=null;
    private String receptaSeleccionada,consulta;
    private DBHelper BD;
    public SQLiteDatabase myDataBase;
    public static String DB_PATH = "/data/data/com.cuinacat.darwin.cuinacat/databases/";
    public static String DB_NAME = "Datos.db";
    public static String rutadb = DB_PATH + DB_NAME;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.carro, container, false);

        ImageButton esborrarRec = (ImageButton) view.findViewById(R.id.esborrarRec);
        esborrarRec.setOnClickListener(lis);
        ImageButton llista = (ImageButton) view.findViewById(R.id.llista);
        llista.setOnClickListener(lis);
        llistaCarro = (ListView) view.findViewById(R.id.listCarro);
        llistaCarro.setChoiceMode(ListView.CHOICE_MODE_SINGLE);

        carregarCarro();
        crearLlista();

        return view;
    }

    View.OnClickListener lis= new View.OnClickListener() {//Listener
        @Override
        public void onClick(View v) {
            Intent intent;
            switch (v.getId()) {
                case R.id.esborrarRec:
                    esborrarRecepta();
                    //REINICIANT ACTIVITY
                    intent = new Intent(getActivity(),TabHost_principal.class);
                    intent.putExtra("FirstTab",2);
                    startActivity(intent);
                    getActivity().finish();
                    break;
                case R.id.llista:
                    if(parseIds.size() < 1){
                        notiToast("ERROR, EL CARRO ES BUIT");
                    }
                    else{
                        intent = new Intent(getActivity(), Llista.class);
                        intent.putExtra("parseIds", parseIds);
                        startActivity(intent);
                        getActivity().overridePendingTransition(R.anim.left_in, R.anim.left_out);
                        getActivity().finish();
                    }
                    break;
            }
        }
    };

    private void crearLlista() {
        ListResultatsAdapter listAdapter = new ListResultatsAdapter(getActivity(), noms, families, selectedItem);
        llistaCarro.setAdapter(listAdapter);
        Log.e("SELECTED ITEM", String.valueOf(selectedItem));
        llistaCarro.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                selectedItem = position;
                receptaSeleccionada = parent.getItemAtPosition(position).toString();
                crearLlista();
            }
        });
    }

    private void carregarCarro() {
        noms = new ArrayList<>();
        parseIds = new ArrayList<>();
        families = new ArrayList<>();
        BD = new DBHelper(getActivity());
        BD.open();
        consulta = "" + "SELECT * FROM Carro";
        try {
            myDataBase = SQLiteDatabase.openDatabase(rutadb, null, SQLiteDatabase.OPEN_READONLY);
            Cursor c = myDataBase.rawQuery(consulta, null);
            if (c != null) {
                if (c.moveToFirst()) {
                    do {
                        noms.add(c.getString(c.getColumnIndex("nom")));
                        parseIds.add(c.getString(c.getColumnIndex("idParse")));
                        families.add(c.getString(c.getColumnIndex("familia")));
                    } while (c.moveToNext());
                }
                c.close();
            }
        } catch (Exception e) {
            Log.e("ERROR CARREGAR CARRO", e.toString());
        }
        BD.close();
    }

    private void esborrarRecepta(){
        BD = new DBHelper(getActivity());
        BD.open();
        try {
            myDataBase = SQLiteDatabase.openDatabase(rutadb, null, SQLiteDatabase.OPEN_READWRITE);
            consulta = "DELETE FROM Carro WHERE nom = '" + receptaSeleccionada + "'";
            myDataBase.execSQL(consulta);
            notiToast("ESBORRADA LA RECEPETA: " + receptaSeleccionada);
        }catch(Exception e){Log.e("ERROR ESBORRAR RECEPTA",e.toString());}
        BD.close();
    }

    private void notiToast(String missatge){
        Toast toast = Toast.makeText(getActivity(), missatge, Toast.LENGTH_LONG);
        toast.show();
    }

}
