package com.cuinacat.darwin.cuinacat;

/**
 * Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
 */

import android.app.Activity;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import java.util.ArrayList;

public class ListResultatsAdapter extends BaseAdapter {

    private final Activity actividad;
    private final ArrayList<String> noms,families;
    private Integer SelectedItem;

    public ListResultatsAdapter(Activity actividad, ArrayList noms, ArrayList families, Integer SelectedItem) {
        super();
        this.actividad = actividad;
        this.noms = noms;
        this.families = families;
        this.SelectedItem=SelectedItem;
    }

    public View getView(int position, View convertView, ViewGroup parent) {

        LayoutInflater inflater = actividad.getLayoutInflater();
        if (convertView == null) {
            convertView = inflater.inflate(R.layout.itemresultats, null, true);
        }

        TextView nom =(TextView)convertView.findViewById(R.id.variable1);
        ImageView imagen = (ImageView)convertView.findViewById(R.id.imagen);
        nom.setText(noms.get(position));

        switch(families.get(position)){
            case "Sopes"://Cumplimiento
                imagen.setImageResource(R.drawable.sopes);
                break;
            case "Amanides"://Fugas
                imagen.setImageResource(R.drawable.amanides);
                break;
            case "Verdures"://IAH
                imagen.setImageResource(R.drawable.verdures);
                break;
            case "Llegums"://CAMBIO DE PESO
                imagen.setImageResource(R.drawable.llegums);
                break;
            case "Arròs"://CAMBIO EPWORTH
                imagen.setImageResource(R.drawable.arros);
                break;
            case "Pasta"://COMUNICACIÓN MÉDICO
                imagen.setImageResource(R.drawable.pasta);
                break;
            case "Carn"://PREMIOS
                imagen.setImageResource(R.drawable.carn);
                break;
            case "Peix"://PREMIOS
                imagen.setImageResource(R.drawable.peix);
                break;
            case "Postres"://PREMIOS
                imagen.setImageResource(R.drawable.postres);
                break;
        }

        if (SelectedItem!=null)
            if(SelectedItem==position) {
                nom.setSelected(true);
                nom.setBackgroundColor(Color.rgb(212, 213, 213));
            }
            else {
                nom.setSelected(false);
            }
        return convertView;
    }

    public int getCount() {
        return noms.size();
    }

    public Object getItem(int arg0) {
        return noms.get(arg0);
    }

    public long getItemId(int position) {
        return position;
    }
}
