package com.cuinacat.darwin.cuinacat;

/**
 * Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
 */

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;
import com.parse.GetCallback;
import com.parse.ParseException;
import com.parse.ParseObject;
import com.parse.ParseQuery;

public class Llista extends Activity {

    private String nomParse=null,ingParse=null,ingredients=null;
    private TextView llistaCompra;
    private Intent intent;
    private ArrayList<String> parseIds = new ArrayList<>();

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        Intent intent = new Intent(this, TabHost_principal.class);
        startActivity(intent);
        overridePendingTransition(R.anim.right_in,R.anim.right_out);
        this.finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.llista);

        //Treiem la barra de notificacions
        this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);

        ImageButton back = (ImageButton) findViewById(R.id.botBack);
        back.setOnClickListener(lis);
        ImageButton save = (ImageButton) findViewById(R.id.botSave);
        save.setOnClickListener(lis);
        ImageButton share = (ImageButton) findViewById(R.id.botShare);
        share.setOnClickListener(lis);
        ImageButton carro = (ImageButton) findViewById(R.id.botCarro);
        carro.setOnClickListener(lis);
        llistaCompra = (TextView) findViewById(R.id.llistaCompra);

        parseIds = getIntent().getStringArrayListExtra("parseIds");
        llistaCompra.setText("LLISTA DE LA COMPRA\n\n");
        crearLlistaCompra();
    }

    View.OnClickListener lis= new View.OnClickListener() {//Listener
        @Override
        public void onClick(View v) {
            switch (v.getId()) {
                case R.id.botBack:
                    intent = new Intent(getApplicationContext(),TabHost_principal.class);
                    startActivity(intent);
                    overridePendingTransition(R.anim.right_in,R.anim.right_out);
                    finish();
                    break;
                case R.id.botSave:
                    guardarLlista();
                    break;
                case R.id.botShare:
                    compartir();
                    break;
                case R.id.botCarro:
                    intent = new Intent(getApplicationContext(),TabHost_principal.class);
                    intent.putExtra("FirstTab",2);
                    startActivity(intent);
                    overridePendingTransition(R.anim.right_in,R.anim.right_out);
                    finish();
                    break;
            }
        }
    };

    private void guardarLlista(){
        //COMPROBEM ESTAT DE LA MEMORIA SD
        String estado = Environment.getExternalStorageState();
        switch (estado){
            case Environment.MEDIA_MOUNTED:
                try {
                    File ruta_sd = Environment.getExternalStorageDirectory();
                    //File ruta_sd2 = getExternalFilesDir(Environment.DIRECTORY_DOCUMENTS);// només vàlid a partir API 19
                    File f = new File(ruta_sd.getAbsolutePath(), "LlistaCompra"+getDate()+".txt");
                    OutputStreamWriter fout = new OutputStreamWriter(new FileOutputStream(f));
                    fout.write(llistaCompra.getText().toString());
                    fout.close();
                    notiToast("Arxiu guardat a "+ruta_sd+"/LlistaCompra"+getDate()+".txt");
                }
                catch (Exception e) {
                    Log.e("GUARDAR LLISTA",e.toString());
                }
                break;
            case Environment.MEDIA_MOUNTED_READ_ONLY:
                notiToast("SD INTERNA SENSE ACCÈS A ESCRIPTURA");
                break;
            default:
                notiToast("SD INTERNA NO DISPONIBLE");
        }
    }

    private void compartir(){
        Intent whatsappIntent = new Intent(Intent.ACTION_SEND);
        whatsappIntent.setType("text/plain");
        whatsappIntent.setPackage("com.whatsapp");
        whatsappIntent.putExtra(Intent.EXTRA_TEXT, llistaCompra.getText().toString());
        try {
            this.startActivity(whatsappIntent);
        } catch (android.content.ActivityNotFoundException ex) {
            notiToast("WHATS APP NO INSTALAT");
        }
    }

    private void notiToast(String missatge){
        Toast toast = Toast.makeText(this, missatge, Toast.LENGTH_LONG);
        toast.show();
    }

    private static String getDate(){
        DateFormat df = new SimpleDateFormat("dd_MM_yyyy", Locale.getDefault());
        Date today = Calendar.getInstance().getTime();
        return  df.format(today);
    }

    private void crearLlistaCompra() {
       for (int i = 0; parseIds.size() > i; i++) {
           ParseQuery<ParseObject> query = ParseQuery.getQuery("Recepta");
           query.getInBackground(parseIds.get(i), new GetCallback<ParseObject>() {
               @Override
               public void done(ParseObject parseObject, ParseException e) {
                   if (e == null) {
                       nomParse = parseObject.getString("nom");
                       ingParse = parseObject.getString("ingredients");
                       Log.e("PARSE EXCEPTION", nomParse);
                       Log.e("PARSE EXCEPTION", ingParse);
                       try {
                           String aux;
                           aux = llistaCompra.getText().toString();
                           llistaCompra.setText(aux + nomParse.toUpperCase() + "\n" + ingParse + "\n\n");
                       } catch (Exception er) {
                           Log.e("PARSE EXCEPTION", er.toString());
                       }
                   } else {
                       Log.e("PARSE EXCEPTION", e.toString());
                   }
               }
           });
       }
    }

}
