package com.cuinacat.darwin.cuinacat;

/**
 * Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
 */

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import com.parse.GetCallback;
import com.parse.ParseException;
import com.parse.ParseFile;
import com.parse.ParseObject;
import com.parse.ParseQuery;

public class Recepta extends Activity {

    private TextView nom,ingredients,preparacio,adicional;
    private ImageView fotoRecepta;
    private ParseFile fotParse;
    String idParse,nomParse,prepParse,ingParse,adiParse;
    private Intent intent;
    private DBHelper BD;
    public SQLiteDatabase myDataBase;
    public static String DB_PATH = "/data/data/com.cuinacat.darwin.cuinacat/databases/";
    public static String DB_NAME = "Datos.db";
    public static String rutadb = DB_PATH + DB_NAME;

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        overridePendingTransition(R.anim.right_in,R.anim.right_out);
        this.finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.recepta);

        //Treiem la barra de notificacions
        this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);

        ImageButton back = (ImageButton) findViewById(R.id.back);
        back.setOnClickListener(lis);
        ImageButton addCarro = (ImageButton) findViewById(R.id.botAddCarro);
        addCarro.setOnClickListener(lis);
        ImageButton  share = (ImageButton) findViewById(R.id.botShare);
        share.setOnClickListener(lis);
        fotoRecepta = (ImageView) findViewById(R.id.fotoRecepta);
        nom = (TextView) findViewById(R.id.nom);
        ingredients = (TextView) findViewById(R.id.ingredients);
        preparacio = (TextView) findViewById(R.id.preparacio);
        adicional = (TextView) findViewById(R.id.adicional);

        //RECULLO ID DE PARSE I CARREGO LA RECEPTA DESDE PARSE
        idParse = getIntent().getStringExtra("idParse");
        carregarRecepta(idParse);
    }

    private void carregarRecepta(String parseId){
        ParseQuery<ParseObject> query = ParseQuery.getQuery("Recepta");
        query.getInBackground(parseId, new GetCallback<ParseObject>() {
            @Override
            public void done(ParseObject parseObject, ParseException e) {
                if (e == null) {
                    prepParse = parseObject.getString("preparacio");
                    nomParse = parseObject.getString("nom");
                    ingParse = parseObject.getString("ingredients");
                    adiParse = parseObject.getString("info");
                    fotParse = parseObject.getParseFile("imatge");
                    try {
                        byte[] imgData = fotParse.getData();//your image data!!
                        Bitmap bmp = BitmapFactory.decodeByteArray(imgData, 0, imgData.length);
                        fotoRecepta.setImageBitmap(bmp);
                        preparacio.setText(prepParse);
                        nom.setText(nomParse);
                        ingredients.setText(ingParse);
                        adicional.setText(adiParse);
                    } catch (ParseException err) {
                        Log.e("PARSE EXCEPTION", err.toString());
                    }
                } else {
                    Log.e("PARSE EXCEPTION", e.toString());
                    error();
                }
            }
        });
    }


    private void error(){
        Toast toast = Toast.makeText(this, "NO SE ENCUENTRA LA RECETA", Toast.LENGTH_LONG);
        toast.show();
    }

    View.OnClickListener lis= new View.OnClickListener() {//Listener
        @Override
        public void onClick(View v) {
            switch (v.getId()) {
                case R.id.back:
                    overridePendingTransition(R.anim.right_in,R.anim.right_out);
                    finish();
                    break;
                case R.id.botAddCarro:
                    afegirCarro();
                    break;
                case R.id.botShare:
                    compartir();
                    break;
            }
        }
    };

    private void compartir(){
        Intent whatsappIntent = new Intent(Intent.ACTION_SEND);
        whatsappIntent.setType("text/plain");
        whatsappIntent.setPackage("com.whatsapp");
        whatsappIntent.putExtra(Intent.EXTRA_TEXT, "");
        try {
            this.startActivity(whatsappIntent);
        } catch (android.content.ActivityNotFoundException ex) {
            notiToast("NO ES POT COMPARTIR , WHATS APP NO INSTALAT");
        }
    }

    private void afegirCarro(){
        int id=0;
        String nom=null,familia=null;
        BD = new DBHelper(this);
        BD.open();

        //RECUPERO INFORMACIÓ DE LA BD INTERNA
        String consulta = "SELECT  id, idParse, nom, familia FROM Recepta WHERE idParse = '"+idParse+"'";
        try {
            myDataBase = SQLiteDatabase.openDatabase(rutadb, null, SQLiteDatabase.OPEN_READWRITE);
            Cursor c = myDataBase.rawQuery(consulta, null);
            if (c != null) {
                if (c.moveToFirst()) {
                    nom = c.getString(c.getColumnIndex("nom"));
                    id = c.getInt(c.getColumnIndex("id"));
                    familia = c.getString(c.getColumnIndex("familia"));
                }
                c.close();
            }
        }catch (Exception e){Log.e("ERROR ADDCARRO REC", e.toString());}

        //GUARDO EN BD INTERNA A LA TAULA CARRO
        try {
            consulta = "INSERT INTO Carro (idRecepta, idParse, nom, familia) VALUES (" + id + ",'" + idParse + "','" + nom + "','" + familia + "')";
            myDataBase.execSQL(consulta);
            notiToast("RECEPTA AFEGIDA AL CARRO");
        }catch (Exception e){Log.e("ERROR ADDCARRO INS",e.toString());}
        BD.close();
    }

    private void notiToast(String missatge){
        Toast toast = Toast.makeText(this, missatge, Toast.LENGTH_LONG);
        toast.show();
    }

}