package com.cuinacat.darwin.cuinacat;

/**
 * Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
 */

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ImageButton;
import android.widget.ListView;

import java.util.ArrayList;

public class Resultats extends Activity {

    ImageButton back,carro;
    ListView resultats;
    Intent intent;
    ArrayList<String> noms = new ArrayList<>();
    ArrayList<String> parseIds = new ArrayList<>();
    ArrayList<String> families = new ArrayList<>();
    private Integer selectedItem=null;

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        Intent intent = new Intent(this, TabHost_principal.class);
        startActivity(intent);
        overridePendingTransition(R.anim.right_in,R.anim.right_out);
        this.finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.resultats);

        //Treiem la barra de notificacions
        this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);

        back = (ImageButton) findViewById(R.id.back);
        back.setOnClickListener(lis);
        carro = (ImageButton) findViewById(R.id.carro);
        carro.setOnClickListener(lis);
        resultats = (ListView) findViewById(R.id.listResultats);
        resultats.setChoiceMode(ListView.CHOICE_MODE_SINGLE);

        //RECUPERO ELS RESULTATS
        noms = getIntent().getStringArrayListExtra("noms");
        parseIds = getIntent().getStringArrayListExtra("parseIds");
        families = getIntent().getStringArrayListExtra("families");
        crearLista();
    }

    private void crearLista() {
        ListResultatsAdapter listAdapter = new ListResultatsAdapter(this, noms, families, selectedItem);
        resultats.setAdapter(listAdapter);
        Log.e("SELECTED ITEM", String.valueOf(selectedItem));
        resultats.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                selectedItem = position;
                veureRecepta(position);
            }
        });
    }

    View.OnClickListener lis= new View.OnClickListener() {//Listener
        @Override
        public void onClick(View v) {
            switch (v.getId()) {
                case R.id.back:
                    intent = new Intent(getApplicationContext(),TabHost_principal.class);
                    startActivity(intent);
                    overridePendingTransition(R.anim.right_in,R.anim.right_out);
                    finish();
                    break;
                case R.id.carro:
                    intent = new Intent(getApplicationContext(),TabHost_principal.class);
                    intent.putExtra("FirstTab",2);
                    startActivity(intent);
                    overridePendingTransition(R.anim.left_in,R.anim.left_out);
                    finish();
                    break;
            }
        }
    };

    private void veureRecepta(int posicio){
        intent = new Intent(getApplicationContext(),Recepta.class);
        intent.putExtra("idParse",parseIds.get(posicio));
        startActivity(intent);
        overridePendingTransition(R.anim.left_in,R.anim.left_out);
        //finish();
    }

}